inf = open("pwgen.in", "r")
ouf = open("pwgen.out", "w")

n = int(inf.readline())
a, b, c = map(int, inf.readline().split())

p = ""
for i in range(n):
    if a > 0:
        p += "AB"[i % 2]
        a -= 1
    elif b > 0:
        p += "ab"[i % 2]
        b -= 1
    else:
        p += "01"[i % 2]

print(p, file = ouf)
